/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 15.12.2010
Author  : sersne
Company : home
Comments: 


Chip type               : ATmega16
Program type            : Application
AVR Core Clock frequency: 10,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega16.h>


#include <stdlib.h>
#include "lcd.c"
#include <io.h>
#include <delay.h>

#include <math.h> 


// 1 Wire Bus functions
#asm
   .equ __w1_port=0x15
   .equ __w1_bit=6
#endasm

#include <1wire.h>

// DS1820 temperature sensor functions
#include <ds1820.h>
#include <delay.h>
// Declare your global variables here
                                             
    

int T,X1,X2,X3;  // signed number for negative and positve temperature manipulating               


// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here

}

// Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Place your code here

TCNT1H=0xC2;
TCNT1L=0xF7;

/*
      switch (++seconds){
        case 5: seconds = 0;
*/

                     T =  ds1820_temperature_10(0)/10;     // read DS1820 every 5 sec.  



                     //    
                     X3=X2;
                     X2=T;
                     if (X2==X3) 
                     {

                           X1=T;
                     }

                     T=(X1);



                     if(T<0)
                     {       


                             lcd_chr(60, 50, 3); //  
                                
                             T = abs(T);   // get only amplitude
                             
                             lcd_chr((T%10)+48,40,3);
                                     
                             if ((T/10) == 0)
                             {               
                                     lcd_chr(58, 30, 3);     // put -
                                     lcd_chr(61, 20, 3);     // 0x00                                                          
//                                     lcd_chr((T/10)+48,40,3);  
                             }
                             else
                             {
                                     lcd_chr(58, 20, 3);     // put -
                                     lcd_chr((T/10)+48,30,3);    

                             }
                             
                     }
                     else
                     {

                             lcd_chr(60, 50, 3); //  
                                
                             T = abs(T);   // get only amplitude
                             
                             lcd_chr((T%10)+48,40,3); //  
                                     
                             if ((T/10) == 0)
                             {               

                                     lcd_chr(61, 20, 3);     // 0x00 
                                     lcd_chr(61, 30, 3);     // 0x00
//                                     lcd_chr((T/10)+48,40,3);  
                             }
                             else
                             {
//                                     lcd_chr(58, 20, 3);     // put -
                                     lcd_chr((T/10)+48,30,3);    

                             }
                             

                     }                   

/*
      }
*/




}

// Declare your global variables here

void main(void)
{
// Declare your local variables here


// Input/Output Ports initialization
// Port A initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTA=0xFF;
DDRA=0xFF;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTB=0xFF;
DDRB=0xFF;

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTC=0xFF;
DDRC=0xFF;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTD=0xFF;
DDRD=0xFF;

//  Timer 0
//TCCR0=0x00;
TCCR0=0x05;
TCNT0=0x64;         

//  Timer 1
TCCR1B=0x05;
TCCR1A=0x00;
TCNT1H=0xC2;
TCNT1L=0xF7;
OCR1BL=0x00;
OCR1BH=0x00;
OCR1AL=0x00;
OCR1AH=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
//ASSR=0x00;
//TCCR2=0x00;
//TCNT2=0x00;
//OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x05;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

      X1=0;
      X2=0;
      X3=0;	               
      T = 0;


// Global enable interrupts

   lcd_init(); 

// 1 Wire Bus initialization
   w1_init();

#asm("sei")

   lcd_contrast(0x40);

//   Lcd_Mode(0);
//   lcd_goto_xy(1,2);
//   lcd_str(str1);   

   Lcd_Mode(1);
   lcd_send(0x0C, LCD_CMD);
//   lcd_goto_xy(15,4);
//   lcd_str(str2);  

/* 
   lcd_chr(str1[0], 20, 3);
   
   lcd_chr(str1[1], 30, 3);
   
   lcd_chr(str1[2], 40, 3);   
   
   lcd_chr(str1[3], 50, 3);   
*/
   
//   Lcd_Mode(2);
//   lcd_send(0x0D, LCD_CMD);
//   lcd_goto_xy(25,6);
//   lcd_str(str1);   



while (1)
      {
      // Place your code here

      };
}
